﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using System.Drawing;
using System.Runtime;
using System.Xml;
using ScriptPortal.Vegas;

namespace Test_Script
{
    public class Class1
    {
        public Vegas myVegas;
        ArrayList RegionStart = new ArrayList();
        ArrayList RegionLength = new ArrayList();

        public void Main(Vegas vegas)
        {
            myVegas = vegas;

            Timecode regStart = null;
            for (long i=0; i<myVegas.Project.Length.FrameCount; i++)
            {
                Timecode EndCode = CheckFoundUnderThisFrame(i);
                if (EndCode != null)
                {
                    if (regStart != null)
                    {
                        if (regStart != Timecode.FromFrames(0))
                        {
                            regStart = regStart - Timecode.FromFrames(1);
                        }
                        addRegionToTimeline(regStart, Timecode.FromFrames(i) - regStart);
                        regStart = null;
                    }
                    i = EndCode.FrameCount;
                }
                else
                {
                    if (regStart == null)
                    {
                        regStart = Timecode.FromFrames(i);
                    }
                }
            }

            closeGaps();
        }

        private Timecode CheckFoundUnderThisFrame(long i)
        {
            Timecode FoundEventEnd = null;

            foreach (Track myTrack in myVegas.Project.Tracks)
            {
                foreach (TrackEvent myEvent in myTrack.Events)
                {
                    if (myEvent.Start.FrameCount <= i && myEvent.End.FrameCount >=i)
                    {
                        if (FoundEventEnd == null)
                        {
                            FoundEventEnd = myEvent.End;
                        }
                        else
                        {
                            if (myEvent.End > FoundEventEnd)
                            {
                                FoundEventEnd = myEvent.End;
                            }
                        }
                    }
                    if (myEvent.Start.FrameCount >= i)
                    {
                        break;
                    }
                }
            }

            return FoundEventEnd;

        }

        private void addRegionToTimeline(Timecode regStart, Timecode regLen)
        {
            RegionStart.Add(regStart);
            RegionLength.Add(regLen);
        }

        private void closeGaps()
        {
            for (int i = RegionStart.Count - 1; i >= 0; i--)
            {
                Timecode regStart = (Timecode)RegionStart[i];
                Timecode regLen = (Timecode)RegionLength[i];

                foreach (Track myTrack in myVegas.Project.Tracks)
                {
                    foreach (TrackEvent evnt in myTrack.Events)
                    {
                        if (evnt.Start > regStart)
                        {
                            evnt.Start = evnt.Start - regLen;
                        }
                    }
                }
            }
        }


    }
}

public class EntryPoint
{
    public void FromVegas(Vegas vegas)
    {
        Test_Script.Class1 test = new Test_Script.Class1();
        test.Main(vegas);
    }
}


